"""added open_interets

Revision ID: h283gd092hd8
Revises: 787b01c0212f
Create Date: 2024-05-27 02:37:06.799955

"""

import sqlalchemy as sa
from alembic import op
from sqlalchemy.dialects import postgresql

# revision identifiers, used by Alembic.
revision = "h283gd092hd8"
down_revision = "787b01c0212f"
branch_labels = None
depends_on = None


def upgrade() -> None:
    # ### commands auto generated by Alembic - please adjust! ###
    exchange_enum = postgresql.ENUM(name="exchange", schema="public", create_type=False)
    op.create_table(
        "open_interest",
        sa.Column("open_interest", sa.Float(), nullable=False),
        sa.Column("exchange", exchange_enum, nullable=False),
        sa.Column("symbol", sa.String(), nullable=False),
        sa.Column("timestamp", sa.BIGINT(), nullable=False),
        sa.Column("datetime", sa.DateTime(), nullable=False),
        sa.Column("id", sa.Integer(), nullable=False),
        sa.Column("created_at", sa.TIMESTAMP(), nullable=False),
        sa.Column("updated_at", sa.TIMESTAMP(), nullable=False),
        sa.PrimaryKeyConstraint("id"),
        schema="crypto",
    )
    op.create_index(
        "ix_open_interest_created_at",
        "open_interest",
        ["created_at"],
        unique=False,
        schema="crypto",
    )
    op.create_index(
        "ix_open_interest_exchange_symbol_timestamp",
        "open_interest",
        ["exchange", "symbol", "timestamp"],
        unique=True,
        schema="crypto",
    )
    op.create_index(
        "ix_open_interest_timestamp",
        "open_interest",
        ["timestamp"],
        unique=False,
        schema="crypto",
    )
    op.create_index(
        "ix_open_interest_time_of_minute",
        "open_interest",
        [sa.text("EXTRACT(minute from datetime)")],
        unique=False,
        schema="crypto",
    )
    op.create_index(
        "ix_open_interest_updated_at",
        "open_interest",
        ["updated_at"],
        unique=False,
        schema="crypto",
    )
    # ### end Alembic commands ###


def downgrade() -> None:
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_index(
        "ix_open_interest_updated_at", table_name="open_interest", schema="crypto"
    )
    op.drop_index(
        "ix_open_interest_time_of_minute", table_name="open_interest", schema="crypto"
    )
    op.drop_index(
        "ix_open_interest_timestamp_exchange_symbol",
        table_name="open_interest",
        schema="crypto",
    )
    op.drop_index(
        "ix_open_interest_created_at", table_name="open_interest", schema="crypto"
    )
    op.drop_table("open_interest", schema="crypto")
    # ### end Alembic commands ###
