"""init

Revision ID: fhj39872hdf9
Revises: a82hf982jd72
Create Date: 2023-05-27 04:37:07.240615

"""

import sqlalchemy as sa
from alembic import op
from sqlalchemy.dialects import postgresql

# revision identifiers, used by Alembic.
revision = "fhj39872hdf9"
down_revision = "a82hf982jd72"
branch_labels = None
depends_on = None


def upgrade() -> None:
    # ### commands auto generated by Alembic - please adjust! ###
    exchange_enum = postgresql.ENUM(name="exchange", schema="public", create_type=False)
    op.create_table(
        "long_short_ratio",
        sa.Column("long_account", sa.DECIMAL(precision=5, scale=4), nullable=False),
        sa.Column("short_account", sa.DECIMAL(precision=5, scale=4), nullable=False),
        sa.Column("long_short_ratio", sa.DECIMAL(precision=6, scale=4), nullable=False),
        sa.Column("exchange", exchange_enum, nullable=False),
        sa.Column("symbol", sa.String(), nullable=False),
        sa.Column("timestamp", sa.BIGINT(), nullable=False),
        sa.Column("datetime", sa.DateTime(), nullable=False),
        sa.Column("id", sa.Integer(), nullable=False),
        sa.Column("created_at", sa.TIMESTAMP(), nullable=False),
        sa.Column("updated_at", sa.TIMESTAMP(), nullable=False),
        sa.PrimaryKeyConstraint("id"),
        schema="crypto",
    )
    op.create_index(
        "ix_long_short_ratio_created_at",
        "long_short_ratio",
        ["created_at"],
        unique=False,
        schema="crypto",
    )
    op.create_index(
        "ix_long_short_ratio_exchange_symbol_timestamp",
        "long_short_ratio",
        ["exchange", "symbol", "timestamp"],
        unique=True,
        schema="crypto",
    )
    op.create_index(
        "ix_long_short_ratio_timestamp",
        "long_short_ratio",
        ["timestamp"],
        unique=False,
        schema="crypto",
    )
    op.create_index(
        "ix_long_short_ratio_time_of_minute",
        "long_short_ratio",
        [sa.text("EXTRACT(minute from datetime)")],
        unique=False,
        schema="crypto",
    )
    op.create_index(
        "ix_long_short_ratio_updated_at",
        "long_short_ratio",
        ["updated_at"],
        unique=False,
        schema="crypto",
    )
    # ### end Alembic commands ###


def downgrade() -> None:
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_index(
        "ix_long_short_ratio_updated_at", table_name="long_short_ratio", schema="crypto"
    )
    op.drop_index(
        "ix_long_short_ratio_time_of_minute",
        table_name="long_short_ratio",
        schema="crypto",
    )
    op.drop_index(
        "ix_long_short_ratio_timestamp_exchange_symbol",
        table_name="long_short_ratio",
        schema="crypto",
    )
    op.drop_index(
        "ix_long_short_ratio_created_at", table_name="long_short_ratio", schema="crypto"
    )
    op.drop_table("long_short_ratio", schema="crypto")
    # ### end Alembic commands ###
